"use strict";

// Технічні вимоги:
// Реалізувати функцію фільтру масиву за вказаним типом даних. Завдання має бути виконане на чистому Javascript без використання бібліотек типу jQuery або React.

// Технічні вимоги:
// Написати функцію filterBy(), яка прийматиме 2 аргументи. Перший аргумент - масив, який міститиме будь-які дані, другий аргумент - тип даних.
// Функція повинна повернути новий масив, який міститиме всі дані, які були передані в аргумент, за винятком тих, тип яких був переданий другим аргументом. Тобто якщо передати масив ['hello', 'world', 23, '23', null], і другим аргументом передати 'string', то функція поверне масив [23, null].

function filterBy(array, typeofData) {
    return array.filter(item => {
        if (typeofData === 'object') {
            return typeof item !== 'object' || item === null;
        } else {
            return typeof item !== typeofData;
        }
    });
}
const data = ['hello', 'world', 23, '23', null];
const filteredData = filterBy(data, `string`);
console.log(filteredData);


// якщо доповнити цей масив що дали нам для прикладу, пустим об'єктом та іншими значеннями то не завжди коректно фільтрує, наприклад коли фільтруєш по 'object' то пропадає і null, бо вважає його за об'єкт

// додано перевірку-порівняння типу даних по обʼєкту
// перевіряємо, чи є typeofData рівним 'object', і якщо так, то ми додатково перевіряємо, чи не є item також null. Таким чином, ми виключаємо null з результату фільтрування, коли фільтруємо за типом 'object'.

// const data = ['hello', 'world', 23, '23', null, {}, [], true];
// const filteredData = filterBy(data, 'object');
// console.log(filteredData);